;******************************************************************
;   PIC16C84
;: Aleksander I. Gurin         a_gurin@kmv.ru
;      .
;       
;   .
;() 17.08.99
;******************************************************************

 list p=16C84, r=dec
 errorlevel 0,-305
 include "P16C84.INC";     inc-
; 


	__config   _CP_OFF & _WDT_ON & _PWRTE_OFF & _XT_OSC

count		equ     0x10	;""   
pres		equ     0x11	;  
push		equ	0x12	;  
tout		equ	0x13	; 
ctout		equ	0x14	;   
dummy		equ	0x15	; - 
;					 (,-    )
sum		equ	0x16	;    
flag	equ 0x17	; 
;  flag
;0 - 	\
;1 - 	 -  10-  
;2 - 	/
;3 - 	 
;4 - 	,     
;5 -	,    
;6 -	,     EEPROM
;7 -	 

;#define	test		;   (     )

	org	h'00'
	goto	main
	org     h'04'
inter	bcf	INTCON,3	;  
	bsf	STATUS,5
	bcf	EECON1,4	;     EEPROM
	bcf	STATUS,5
	bsf	flag,6
	retfie

read	clrf	count		;  
	incf	count,1	
	clrf	pres	 
	clrf	push
	bcf	flag,5
seta	comf	count,0		;   " "
	movwf	PORTA		;  RA
	call	rest		;     RA
scanb	movf	PORTB,0		;  RB
	movwf	pres
	comf	pres,1
	xorlw	0x70
	movwf	pres
	swapf	pres,1
	incf	pres,1
	decfsz	pres,1		;     -
	goto	key		;,  
	bcf	STATUS,C	;    -
	rlf	count,1		;   
	btfss	count,4		;   -
	goto	seta
	goto	eoread		;   .

;      
;  push    (  -   
;  ):
;"1" - 09h 	"2" - 0Ah 	"3" - 0Ch
;"4" - 11h	"5" - 12h	"6" - 14h
;"7" - 21h	"8" - 22h	"9" - 24h
;"*" - 41h	"0" - 42h	"#" - 44h
;       EEPROM
;,     EEPROM   - .
;   42h   20h  EEPROM.
;    "0".

key	movf	count,0
	movwf	push
	rlf	push,1
	rlf	push,1
	rlf	push,1
	movf 	pres,0
	iorwf	push,1
	btfss	flag,5		;       "" -
	call	beep		; ""
	bsf	flag,5		;   5  flag,
;				    ""   
;				  
	goto	scanb		;...   - 
eoread	return

beep	movlw   0xff		;  
	movwf   ctout
	ifndef	test
loop1	bcf	PORTB,2		;  1 
	bsf	PORTB,1		; 2  RB
	call	rest		;...  
	bcf	PORTB,1		;   1 
	bsf	PORTB,2		; 2  RB
	call	rest		;...   
	decfsz	ctout,1
	goto	loop1
	bcf	PORTB,1
	bcf	PORTB,2
	endif
	return

rest	movlw   0x19		; 
	movwf   tout
loop2	nop	
	ifndef	test		;     
	decfsz	tout,1
	goto	loop2
	endif
	return

compare	clrf	sum		;  
	movlw   0x20
	movwf   FSR
mark02	movf	0x00,0		;   
	addwf	sum,1		;  20h-27h RAM
	incf	FSR,1		;     sum
	movlw	0x28
	xorwf	FSR,0
	btfss	STATUS,Z
	goto	mark02
	return

sec	nop			;   1 .
	ifndef	test		;     
	bsf	STATUS,5
	movlw   0x0e		; ,    
	movwf	0x81		;    
	bcf	STATUS,5
	clrwdt			; WDT
	sleep			;...  
	endif
	return

main	bsf	STATUS,5
	movlw   0x00		;  RA  
        movwf   TRISA
	movlw   0x70		; RB0-RB3  RB7  
	movwf   TRISB		;... RB4-RB6 -  
	bcf	0x81,7
	bcf	STATUS,5
	movlw   0x00
	movwf   INTCON		; 
	movlw	0x1f
	movwf	PORTA
	clrf	PORTB
	movlw	0x03		;   
	movwf	dummy
mark00	movlw   0x20		; 8   
	movwf   FSR		; EEPROM (20h-27h)
mark01	movf	FSR,0		; ROM (20h-27h) 
	movwf	EEADR
	bsf	STATUS,5
	bsf	EECON1,RD
	bcf	STATUS,5
	movf	EEDATA,0
	movwf	0x00
	incf	FSR,1
	movlw	0x28
	xorwf	FSR,0
	btfss	STATUS,Z
	goto	mark01
	movlw	0x20
	movwf	FSR
	clrf	flag		; 
	goto	loop0
open	movlw	0x0f		;  
	movwf	PORTA
	call	sec		;  
	call	beep		;"" 
	bsf	PORTB,3		;   
	call	sec		;  
mark04	bsf	PORTA,4		;  
	clrf	PORTB
	call	beep		;  ""
	goto	main		;...   
loop0	clrf	INTCON		;  
	clrwdt			; WDT
	call	read		;  
mark09	movlw	0x00 
	xorwf	push,0
	btfss	STATUS,Z	;    -
	goto	mark05		;  mark05
	movlw	0x10		; RA0-RA3
	movwf	PORTA
loop7	movlw	0x88		;   RB
	movwf	INTCON
	bsf	STATUS,5	; WDT
	movlw   0x0f
	movwf	0x81	
	bcf	STATUS,5
	clrwdt
	sleep	
	btfsc	INTCON,0	;       -
	goto	loop0		; 
	btfss	flag,4
	goto	loop7
	incf	flag,1
	btfsc	flag,2		; 10 .   - 
	goto	main		;   
	goto 	loop7		;   -  ...
mark05	movlw	0x41		;...  ,  .
	xorwf	push,0
	btfss	STATUS,Z	;  "*" -
	goto	mark06
	goto	mark10		;  mark10
mark06	movlw	0x44
	xorwf	push,0
	btfss	STATUS,Z	;  "#" -
	goto	mark07
	goto	mark03		;  mark03
mark07	movf	push,0		;    
	xorwf	0x00		;...   EEPROM
	incf	FSR,1
	movlw	0x10		;  10-  
	movwf	flag
	goto	loop0		;...      
mark03	bcf	STATUS,C	;   + "#"
	call	compare		;   
	incf	sum,1
	decfsz	sum,1		;   -
	goto	mark08
	goto	open		; 
mark08	decfsz	dummy		;"" -     ,-     
	goto	mark00		;  ...
;				     ! 
;				    !
	movlw	0x40		
	movwf	dummy
	clrf	PORTA
loop4	clrf	PORTB
	call	beep		;""  
	call	sec
	bsf	PORTA,4
	decfsz	dummy,1
	goto	loop4
	goto	main		;...   
mark10	bcf	STATUS,C	;   + "*" -   
	call	compare		;   
	incf	sum,1
	decfsz	sum,1		;  "_"  -
	goto	main
	movlw	0x20
	movwf	FSR
	bcf	PORTA,4		;  
	call	beep		; ""
	bsf	PORTA,4		;   
loop6	clrwdt
	call	read		; 
	movlw	0x00
	xorwf	push,0
	btfss	STATUS,Z	; -  -
	goto	mark11		
	goto	loop6
mark11	movlw	0x41		;... ,  - "*"
	xorwf	push,0
	btfss	STATUS,Z	; "*" -
	goto	mark12
	goto	main		; ,   
mark12	movlw	0x44		;... ,  - "#"
	xorwf	push,0
	btfss	STATUS,Z	; "#" -
	goto	mark13
	goto	save		;...    "_"      EEPROM
mark13	movf	push,0		;   "" -     "_"
	movwf	0x00		;   RAM
	incf	FSR,1
	movlw	0x29
	xorwf	FSR,0
	btfss	STATUS,Z	;    9- 
	goto	loop6
	call	sec		;  ""     "_"
	call	beep
	call	sec
	call	beep
	goto	main
save	call	sec		;    prom
	bcf	PORTA,4
	call	beep
	bsf	PORTA,4
	clrwdt
	movlw	0x20
	movwf	FSR
loop5	bsf	STATUS,5	;  (    EEPROM)
	movlw	0x04
	movwf	EECON1
	bcf	STATUS,5
	bcf	flag,6
	movf	FSR,0
	movwf	EEADR
	movf	0x00,0
	movwf	EEDATA
	movlw	0xc0
	movwf	INTCON
	bsf	STATUS,5
	movlw	0x09
	movwf	0x81
	movlw	0x55
 movwf	EECON2
	movlw	0xaa
	movwf	EECON2
	bsf	EECON1,WR
loop8	bcf	STATUS,5
	btfss	flag,6		;   
	goto	loop8		;  
	clrf	INTCON
	clrwdt
	bcf	flag,6
	incf	FSR,1		;...       20h-27h  ROM  EEPROM
	movlw	0x28	
	xorwf	FSR,0
	btfss	STATUS,Z
	goto	loop5
	bsf	STATUS,5
	clrf	EECON1
	clrf	EECON2
	movlw	0x0e
	movwf	0x81
	bcf	STATUS,5
	clrwdt			; 
stop	bcf	PORTA,4		;  
	call	beep		; ""
	bsf	PORTA,4		;   
	call	sec		; 
	bcf	PORTA,4		;  
	call	beep		; ""
	bsf	PORTA,4		;   
	goto	main		;...   
 end	


--------------------------------------------------------------------------------

: Aleksander I. Gurin. a_gurin@kmv.ru 